function newMenuButton(x, y, w, h, inMenu, lable, toScene)
  local button = {x = x, y = y, w = w, h = h, inMenu = inMenu, lable = lable, toScene}
  menuButtons[#menuButtons + 1] = button
  function draw(self)
    if menu == self.inMenu then
      love.graphics.setFont(fontSize[30])
      love.graphics.setColor(0.5, 0.5, 1)
      love.graphics.rectangle("fill", self.x, self.y, self.w, self.h)
      love.graphics.setColor(0, 0, 0)
      love.graphics.rectangle("line", self.x, self.y, self.w, self.h)
      love.graphics.setColor(0, 0, 0)
      love.graphics.printf(self.lable, self.x, self.y + self.h/3 ,self.w, "center")
    end
  end
  function clicked(self, X, Y)
    if menu == self.inMenu and isInside(self.x, self.y, self.w, self.h, X, Y) then
      if toScene[1] == 0 then
        if menu >= 2 then
          startGame(maps[inMenu][toScene[2]])
        end
      end
      menu = toScene[1]
      return true
    end
    return false
  end
  button.draw = draw
  button.clicked = clicked
end
editor.initMenu = {w = 10, h = 10, addW = 0, addH = 0, button = {{x = 100, y = 50, w = 600, h = 100}, {x = 100, y = 200, w = 600, h = 100}}}
function editor.initMenu:draw()
  local buttons = self.button
  love.graphics.setFont(fontSize[30])
  for i = 1, #buttons do
    local button = buttons[i]
    love.graphics.setColor(0.5, 0.5, 1)
    love.graphics.rectangle("fill", button.x, button.y, button.w, button.h)
    love.graphics.setColor(0, 0, 0)
    love.graphics.rectangle("line", button.x, button.y, button.w, button.h)
    if i >= 1 and i <= 2 then
      love.graphics.setColor(0, 0, 0)
      love.graphics.setFont(fontSize[60])
      love.graphics.printf("—", button.x + 10, button.y + 10, button.w - 10, "left")
      love.graphics.printf("+", button.x, button.y + 10, button.w - 10, "right")
    end
    love.graphics.setFont(fontSize[30])
  end
  love.graphics.setColor(0, 0, 0)
  love.graphics.printf("Width: " .. self.w, buttons[1].x, buttons[1].y + buttons[1].h/3, buttons[1].w, "center")
  love.graphics.printf("Height: " .. self.h, buttons[2].x, buttons[2].y + buttons[2].h/3, buttons[2].w, "center")
end
function editor.initMenu:update(dt)
  if self.addW ~= 0 and self.w + self.addW >= 5 then self.w = self.w + self.addW end
  if self.addH ~= 0 and self.h + self.addH >= 5 then self.h = self.h + self.addH end
end
function editor.initMenu:mousepressed(x, y, button)
  local buttons = self.button
  if isInside(buttons[1].x, buttons[1].y, 100, 100, x, y) then
    self.addW = -1
  elseif isInside(buttons[2].x, buttons[2].y, 100, 100, x, y) then
    self.addH = -1
  elseif isInside(buttons[1].x + buttons[1].w - 100, buttons[1].y, 100, 100, x, y) then
    self.addW = 1
  elseif isInside(buttons[2].x + buttons[2].w - 100, buttons[2].y, 100, 100, x, y) then
    self.addH = 1
  end
  if isInside(50, 450, 700, 100, x, y) then
    editor.view = {x = 0, y = 0, unitX = 0, unitY = 0}
    editor.map = {monsters = {}, {}, {}}
    editor.map.width = self.w
    editor.map.height = self.h
    editor.choose = {1, 1, 0}
    editor.slot = {{},{},{},{}}
    editor.slot[1][1] = {lable = "Tiles", toSlot = {2, 1}}
    editor.slot[1][2] = {lable = "Items", toSlot = {3, 1}}
    editor.slot[1][3] = {lable = "Monsters", toSlot = {4, 1}}
    editor.slot[1][4] = {Type = "Player", image = images.player[1].down}
    editor.slot[1][10] = {lable = "Save"}
    function initItems(Type, inSlot)
      local i = 1
      local length = 0
      if Type == "Tile" then length = images.ground.length
      elseif Type == "Item" then length = images.item.length
      elseif Type == "Monster" then length = images.monster.length
      end
      for j = 1, length do
        if i % 10 == 1 then
          editor.slot[inSlot][i] = {lable = "Back", toSlot = {1, 1}}
          i = i + 1
        elseif i % 10 == 0 and j < length then
          editor.slot[inSlot][i] = {lable = "Next", toSlot = {1, math.ceil((i-1)/10) + 1}}
          i = i + 1
        end
        editor.slot[inSlot][i] = {Type = Type, model = j}
        if Type == "Tile" then editor.slot[inSlot][i].image = images.ground[editor.slot[inSlot][i].model]
        elseif Type == "Item" then editor.slot[inSlot][i].image = images.item[editor.slot[inSlot][i].model]
        elseif Type == "Monster" then editor.slot[inSlot][i].image = images.monster[editor.slot[inSlot][i].model]
        end
        i = i + 1
      end
    end
    initItems("Tile", 2)
    initItems("Item", 3)
    initItems("Monster", 4)
    for i = 1, #editor.slot do
      for j = 1, 100 do
        if editor.slot[i][j] ~= nil then
          editor.slot[i][j].p = {i, j}
          editor.slot[i][j].x = 15 + ((j - 1) % 10) * 68
        end
      end
    end
    function editor.map:clicked(X, Y, button)
      if button == 2 and editor.choose.item ~= nil then
        editor.choose.item = nil
        drag = nil
        return true
      end
      local view = editor.view
      local map = editor.map
      for y = view.y - 8, view.y + 8 do
        for x = view.x - 11, view.x + 11 do
          local grid = {w = 40, h = 40, map[1][map.width*y+x+1], map[2][map.width*y+x+1]}
          if grid[1] ~= nil and x >= 0 and x < map.width then
            local screenY = (y-(view.y-7))*40 - view.unitY
            local screenX = (x-(view.x-10))*40 - view.unitX
            if editor.choose.item ~= nil and isInside(screenX, screenY, grid.w, grid.h, X, Y) then
              local item = editor.choose.item
              if item.Type == "Tile" then
                map[1][map.width*y+x+1] = item.model
              elseif item.Type == "Item" and (map.player == nil or map.player.x ~= x or map.player.y ~= y) then
                if item.model == map[2][map.width*y+x+1] then
                  map[2][map.width*y+x+1] = 0
                else
                  local putItem = true
                  for i = 1, #map.monsters do
                    if map.monsters[i].x == x and map.monsters[i].y == y then
                      putItem = false
                      break
                    end
                  end
                  if putItem then map[2][map.width*y+x+1] = item.model end
                end
              elseif item.Type == "Monster" and map[2][map.width*y+x+1] == 0 and (map.player == nil or map.player.x ~= x or map.player.y ~= y) then
                local i = #map.monsters + 1
                for j = 1, #map.monsters do
                  if map.monsters[j].x == x and map.monsters[j].y == y then
                    i = j
                    break
                  end
                end
                if map.monsters[i] ~= nil and map.monsters[i].model == item.model then
                  table.remove(map.monsters, i)
                else
                  map.monsters[i] = {x=x,y=y,model=item.model, 0}
                  initMonster(map.monsters[i])
                end
              elseif item.Type == "Player" and map[2][map.width*y+x+1] == 0 then
                local occupied = false
                for i = 1, #map.monsters do
                  if map.monsters[i].x == x and map.monsters[i].y == y then
                    occupied = true
                    break
                  end
                end
                if occupied ~= true then
                  editor.map.player = {x = x, y = y, image = item.image}
                  editor.choose.item = nil
                  drag = nil
                end
              end
              return true
            end
          end
        end   
      end
      return false
    end
    function editor.slot:draw()
      local page = editor.choose[2]
      love.graphics.setColor(1, 1, 1)
      love.graphics.draw(images.editorItem[1], 5, 5, 0, 0.6)
      for i = 1 + 10*(page-1), 10*page do
        local item = self[editor.choose[1]][i]
        if item ~= nil then
          if item.image ~= nil then
            love.graphics.setColor(1, 1, 1)
            love.graphics.draw(item.image, item.x + 5, 30, 0, 0.8)
          end
          if item.lable ~= nil then
            love.graphics.setColor(1, 1, 1)
            love.graphics.setFont(fontSize[20])
            love.graphics.printf(item.lable, item.x, 40, 60, "center")
          end
        end
      end
    end
    function editor.slot:clicked(x, y, button)
      local page = editor.choose[2]
      for i = 1 + 10*(page-1), 10*page do
        local item = self[editor.choose[1]][i]
        if item ~= nil and isInside(item.x, 10, 60, 80, x, y) then
          if item.toSlot ~= nil then
            editor.choose[1] = item.toSlot[1]
            editor.choose[2] = item.toSlot[2]
            editor.choose[3] = 0
          end
          if button == 2 and item.Type ~= nil then
            drag = {item = self, image = item.image, x = x, y = y, imageSize = 0.7, keepDrag = true}
            editor.choose.item = {Type = item.Type, model = editor.slot[editor.choose[1]][i].model, image = item.image}
          end
          if item.lable ~= nil then
            if item.lable == "Save" then
              saveMap()
            end
          end
          return true
        end
      end
      return false
    end
    for i = 1, 2 do
      for y = 0, self.h - 1 do
        for x = 0, self.w - 1 do
          local p = y*self.w + x + 1
          if i == 1 then editor.map[i][p] = 1
          elseif i == 2 then
            editor.map[i][p] = 0
            if y == 0 or x == 0 or y == self.h - 1 or x == self.w - 1 then
              editor.map[i][p] = 4
            end
          end
        end
      end
    end
  end
end
function editor.initMenu:mousereleased(x, y, button)
  self.addW = 0
  self.addH = 0
end
function editor:draw()
  local view = self.view
  local map = self.map
  for y = view.y - 8, view.y + 8 do
    for x = view.x - 11, view.x + 11 do
      local grid = {map[1][map.width*y+x+1], map[2][map.width*y+x+1]}
      if grid[1] ~= nil and x >= 0 and x < map.width then
        local screenY = (y-(view.y-7))*40 - view.unitY
        local screenX = (x-(view.x-10))*40 - view.unitX
        love.graphics.setColor(1, 1, 1)
        if map[1][map.width*y+x+1] >= 1 then
          love.graphics.draw(images.ground[map[1][map.width*y+x+1]], screenX, screenY, 0, 0.63)
        end
        if map[2][map.width*y+x+1] >= 1 then
          love.graphics.draw(images.item[map[2][map.width*y+x+1]], screenX, screenY, 0, 0.63)
        end
        love.graphics.setColor(0, 0, 0)
        love.graphics.rectangle("line", screenX, screenY, 40, 40)
      end
    end
  end
  for y = view.y - 8, view.y + 8 do
    for x = view.x - 11, view.x + 11 do
      local grid = {map[1][map.width*y+x+1], map[2][map.width*y+x+1]}
      if grid[1] ~= nil and x >= 0 and x < map.width then
        local screenY = (y-(view.y-7))*40 - view.unitY
        local screenX = (x-(view.x-10))*40 - view.unitX
        love.graphics.setColor(1, 1, 1)
        for i = 1, #map.monsters do
          local monster = map.monsters[i]
          if monster.x == x and monster.y == y then
            love.graphics.setColor(1, 1, 1)
            love.graphics.draw(images.monster[monster.model] ,screenX, screenY, 0, 0.63)
            love.graphics.setColor(1, 0, 0)
            love.graphics.rectangle("fill", screenX, screenY - 5, 39, 10)
            love.graphics.setColor(0, 1, 0)
            love.graphics.rectangle("fill", screenX, screenY - 5, 39*monster.HP/monster.maxHP, 10)
            love.graphics.setColor(0, 0, 0)
            love.graphics.rectangle("line", screenX, screenY - 5, 39, 10)
            love.graphics.setFont(fontSize[10])
            love.graphics.printf(monster.HP, screenX, screenY - 6, 39, "center")
          end
        end
        if self.map.player ~= nil and self.map.player.x == x and self.map.player.y == y then
          local player = self.map.player
          love.graphics.setColor(1, 1, 1)
          love.graphics.draw(player.image, screenX, screenY, 0, 0.65)
        end
      end
    end
  end
  self.slot:draw()
end
function editor:update(dt)
  local view = self.view
  if view.left then
    view.unitX = view.unitX - 8
  end
  if view.right then
    view.unitX = view.unitX + 8
  end
  if view.up then
    view.unitY = view.unitY - 8
  end
  if view.down then
    view.unitY = view.unitY + 8
  end
  if view.unitX <= -40 then
    view.unitX = 0
    view.x = view.x - 1
  elseif view.unitX >= 40 then
    view.unitX = 0
    view.x = view.x + 1
  end
  if view.unitY <= -40 then
    view.unitY = 0
    view.y = view.y - 1
  elseif view.unitY >= 40 then
    view.unitY = 0
    view.y = view.y + 1
  end
end
function editor:mousepressed(x, y, button)
  if editor.slot:clicked(x, y, button) then return end
  if editor.map:clicked(x, y, button) then return end
end
function editor:mousereleased(x, y, button)
  
end
function editor:keypressed(k)
  if k == "left" then editor.view.left = true
  elseif k == "right" then editor.view.right = true
  elseif k == "up" then editor.view.up = true
  elseif k == "down" then editor.view.down = true
  end
end
function editor:keyreleased(k)
  if k == "left" then editor.view.left = false
  elseif k == "right" then editor.view.right = false
  elseif k == "up" then editor.view.up = false
  elseif k == "down" then editor.view.down = false
  end
end
function saveMap()
  printMap()
  drag = nil
  newMenuButton(50+150*(#maps[3] % 5), 50+150*math.floor(#maps[3]/5), 100, 100, 3, #maps[3] + 1, {0, #maps[3] + 1})
  if editor.map.player == nil then return end
  maps[3][#maps[3] + 1] = {width = editor.map.width, goals = 0, keys = 0}
  local map = maps[3][#maps[3]]
  map.monsters = editor.map.monsters
  map[1] = editor.map[1]
  map[2] = editor.map[2]
  map.player = {x = editor.map.player.x, y = editor.map.player.y}
  for i = 1, #map[2] do
    if map[2][i] == 1 then
      map.goals = map.goals + 1
    elseif map[2][i] == 2 then
      map.keys = map.keys + 1
    end
  end
  menu = 1
end
function printMap()
  local map = editor.map
  local map_string = "{width = " .. editor.map.width .. ", monsters = {"
  for i = 1, #map.monsters do
    local monster = map.monsters[i]
    map_string = map_string .. "{x=" .. monster.x .. ",y=" .. monster.y .. ",model=" .. monster.model
    for j = 1, #monster do
      if monster[j] > 0 then
        map_string = map_string .. "," .. monster[j]
      end
    end
    map_string = map_string .. "}"
    if i < #map.monsters then
      map_string = map_string .. ","
    end
  end
  map_string = map_string .. "}, {"
  --for i = 1, #map[1]
  print_r(map)
end
function print_r(t)
  local print_r_cache={}
  local function sub_print_r(t,indent)
    if (print_r_cache[tostring(t)]) then
      print(indent.."*"..tostring(t))        
    else
      print_r_cache[tostring(t)]=true
      if (type(t)=="table") then
        for pos,val in pairs(t) do
          if (type(val)=="table") then
            print(indent.."["..pos.."] = "..tostring(t).." {")
            sub_print_r(val,indent..string.rep(" ",string.len(pos)+8))
            print(indent..string.rep(" ",string.len(pos)+6).."}")
          elseif (type(val)=="string") then
            print(indent.."["..pos..'] = "'..val..'"')
          else
            print(indent.."["..pos.."] = "..tostring(val))
          end
        end
      else
        print(indent..tostring(t))
      end
    end
  end
  if (type(t)=="table") then
    print(tostring(t).." {")
    sub_print_r(t,"  ")
    print("}")
  else
    sub_print_r(t,"  ")
  end
  print()
end